
#ifndef __EVA4CAP_LIB_H_____
#define __EVA4CAP_LIB_H_____

//
//#include "eepreport.h"
// eepReport.h: interface for the eepReport class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_EEPREPORT_H__B49C40B5_9838_4EEB_AEAD_0AC7B74E7E60__INCLUDED_)
#define AFX_EEPREPORT_H__B49C40B5_9838_4EEB_AEAD_0AC7B74E7E60__INCLUDED_


// eeprom virtual status report code
enum {
	EEP_ERASE_ALL_START = 0,
	EEP_ERASE_ALL_ENDED,
	EEP_PROG_START,
	EEP_PROG_SECTOR,
	EEP_PROG_ENDED,
	EEP_VERIFY_START,
	EEP_VERIFY_ENDED,
	EEP_PROG_FILE_OPEN_ERROR,
	EEP_LOAD_FILE
};

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

virtual class eepReport  
{
public:
	eepReport() {}
	virtual ~eepReport() {};
	virtual void Status(int msg,int par) {};
};

#endif // !defined(AFX_EEPREPORT_H__B49C40B5_9838_4EEB_AEAD_0AC7B74E7E60__INCLUDED_)


#ifdef __cplusplus
extern "C" {
#endif

#define	BYTE	unsigned char
#define WORD	unsigned short
#define DWORD	unsigned long


enum {
	VM_FULL_YUV_I=0,
	VM_FULL_YUV_NI,
	VM_FULL_MONO_I,
	VM_FULL_MONO_NI,
	VM_HALF_YUV_ODD,
	VM_HALF_MONO_ODD,
	VM_HALF_YUV_EVEN,
	VM_HALF_MONO_EVEN,
	VM_HALF_YUV_ODD_EVEN,
	VM_HALF_MONO_ODD_EVEN
};

__declspec( dllexport ) BOOL EVA_Init();
__declspec( dllexport ) BOOL EVA_End();

__declspec( dllexport ) int EVA_GetMaxCards();
__declspec( dllexport ) int EVA_GetMaxChannels(int card_num);

__declspec( dllexport ) int EVA_WriteReg(int card_num,DWORD offset,DWORD data);
__declspec( dllexport ) int EVA_ReadReg(int card_num,DWORD offset,DWORD *data);

__declspec( dllexport ) BYTE *EVA_DmaAlloc(int card_num,int channel,DWORD size);
__declspec( dllexport ) void EVA_DmaFree(int card_num,int channel);

__declspec( dllexport ) int EVA_GetDmaPos(int card_num,int channel,DWORD *pos);
__declspec( dllexport ) int EVA_GetDmaPosOvl(int card_num,int channel,DWORD *pos);

__declspec( dllexport ) int EVA_CancelGetDmaPos(int card_num,int channel);
__declspec( dllexport ) int EVA_WaitForDmaEnd(int card_num,int channel);
__declspec( dllexport ) int EVA_DmaStop(int card_num,int channel);
__declspec( dllexport ) int EVA_DmaRead(int card_num,int channel,DWORD intlength,DWORD length);
__declspec( dllexport ) int EVA_DmaReadInter(int card_num,int channel,DWORD intlength,DWORD length,DWORD interlength);

__declspec( dllexport ) void EVA_SetCapMode(int card_num,int channel,int start,int cap_width,int cap_height,int cap_frames,int cap_ntsc_pal,int cap_mode);
__declspec( dllexport ) int EVA_DmaCapStart(int card_num,int channel);
__declspec( dllexport ) int EVA_CapEnable(int card_num,DWORD channels);
__declspec( dllexport ) int EVA_CapStart(int card_num,DWORD channel);
__declspec( dllexport ) int EVA_CapStop(int card_num,DWORD channel);

// eeprom program 
__declspec( dllexport ) void EVA_SetRpt(int card_num,eepReport *report);
__declspec( dllexport ) int EVA_Prog(int card_num,char *filename);

// i2c control functions
__declspec( dllexport ) void EVA_I2cInit(int card_num);
__declspec( dllexport ) void EVA_I2cClr(int card_num);
__declspec( dllexport ) int EVA_I2cWrite(int card_num,BYTE chan,BYTE chip_addr,BYTE  sub_addr,BYTE length, BYTE *buffer);
__declspec( dllexport ) int EVA_I2cRead(int card_num,BYTE chan, BYTE chip_addr,BYTE sub_addr, BYTE *dout);


// image conversion functions
__declspec( dllexport ) void EVA_MakeBMPHeader(int card_num,BITMAPINFOHEADER *pbmiHdr, BITMAPFILEHEADER *pbmfHdr,int Width,int Height);
__declspec( dllexport ) void EVA_MONOtoBMPImage(int card_num,BYTE *rawImage, BYTE *bmpImage,int Width,int Height);
__declspec( dllexport ) void EVA_YUVtoBMPImage(int card_num,BYTE *rawImage, BYTE *bmpImage,int Width,int Height);

// 
__declspec( dllexport ) void EVA_MakeBMPHeaderCh(int card_num,int channel,BITMAPINFOHEADER *pbmiHdr, BITMAPFILEHEADER *pbmfHdr);
__declspec( dllexport ) void EVA_RAWtoBMPImage(int card_num,int channel,BYTE *rawImage, BYTE *bmpImage, int pos);
__declspec( dllexport ) void EVA_SetUsed(int card_num,DWORD used);
__declspec( dllexport ) void EVA_GetUsed(int card_num,DWORD *used);

#ifdef __cplusplus
}
#endif

#endif





